#==============================================================================
#  FIX_ScreenAnimation
#------------------------------------------------------------------------------
#  Version    1.1.0
#  Modified   2017-10-29
#  By         panda (werepanda.jp) http://www.werepanda.jp/
#------------------------------------------------------------------------------
# ʑŜw肳ꂽ퓬AjłSĂ̓GLN^[\Ƃ
# vZbgXNvg̕sC܂B
#==============================================================================

class Game_Battler
  #--------------------------------------------------------------------------
  #  JCX^Xϐ
  #--------------------------------------------------------------------------
  attr_accessor :animation_flash_only     # Aj[V tbV̂ݕ\
  #--------------------------------------------------------------------------
  #  XvCgƂ̒ʐMpϐNAiǉ`j
  #--------------------------------------------------------------------------
  alias _panda_fix_screenanimation_clear_sprite_effects clear_sprite_effects
  def clear_sprite_effects
    _panda_fix_screenanimation_clear_sprite_effects
    @animation_flash_only = false
  end
end

class Sprite_Base < Sprite
  #--------------------------------------------------------------------------
  #  Aj[V̊Jniǉ`j
  #--------------------------------------------------------------------------
  alias _panda_fix_screenanimation_start_animation start_animation
  def start_animation(animation, mirror = false, flash_only = false)
    @animation_flash_only = flash_only
    _panda_fix_screenanimation_start_animation(animation, mirror)
  end
  #--------------------------------------------------------------------------
  #  Aj[VXvCg̐ݒiǉ`j
  #     frame : t[f[^ (RPG::Animation::Frame)
  #--------------------------------------------------------------------------
  alias _panda_fix_screenanimation_animation_set_sprites animation_set_sprites
  def animation_set_sprites(frame)
    return if @animation_flash_only # tbV̂ݕ\Ȃ`悵Ȃ
    _panda_fix_screenanimation_animation_set_sprites(frame)
  end
  #--------------------------------------------------------------------------
  #  SE ƃtbṼ^C~Oiǉ`j
  #     timing : ^C~Of[^ (RPG::Animation::Timing)
  #--------------------------------------------------------------------------
  alias _panda_fix_screenanimation_process_timing animation_process_timing
  def animation_process_timing(timing)
    if @animation_flash_only && timing.flash_scope == 2
      # tbV̂ݕ\ʑŜ̃tbVȂSÊݖ炷
      timing.se.play
    else
      _panda_fix_screenanimation_process_timing(timing)
    end
  end
end

class Sprite_Battler < Sprite_Base
  #--------------------------------------------------------------------------
  #  VGtFNg̐ݒiĒ`j
  #--------------------------------------------------------------------------
  def setup_new_effect
    if @battler.white_flash
      @effect_type = WHITEN
      @effect_duration = 16
      @battler.white_flash = false
    end
    if @battler.blink
      @effect_type = BLINK
      @effect_duration = 20
      @battler.blink = false
    end
    if not @battler_visible and @battler.exist?
      @effect_type = APPEAR
      @effect_duration = 16
      @battler_visible = true
    end
    if @battler_visible and @battler.hidden
      @effect_type = DISAPPEAR
      @effect_duration = 32
      @battler_visible = false
    end
    if @battler.collapse
      @effect_type = COLLAPSE
      @effect_duration = 48
      @battler.collapse = false
      @battler_visible = false
    end
    if @battler.animation_id != 0
      animation = $data_animations[@battler.animation_id]
      mirror = @battler.animation_mirror
      flash_only = @battler.animation_flash_only  # tbV̂ݕ\
      start_animation(animation, mirror, flash_only)
      @battler.animation_id = 0
    end
  end
end

class Scene_Battle < Scene_Base
  #--------------------------------------------------------------------------
  #  ʏAj[V̕\iĒ`j
  #     targets      : Ώێ҂̔z
  #     animation_id : Aj[V ID
  #     mirror       : E]
  #--------------------------------------------------------------------------
  def display_normal_animation(targets, animation_id, mirror = false)
    animation = $data_animations[animation_id]
    if animation != nil
      to_screen = (animation.position == 3)       # ʒuuʁvH
      flash_only = false                          # tbV̂ݕ\H
      for target in targets.uniq
        target.animation_id = animation_id
        target.animation_mirror = mirror
        # S̗pȂŏ̑Ώێ҈ȊO̓tbV̂ݕ\
        target.animation_flash_only = flash_only
        flash_only = true if to_screen
        wait(20, true) unless to_screen           # P̗pȂEFCg
      end
      wait(20, true) if to_screen                 # S̗pȂEFCg
    end
  end
end
